require 'rubygems/commands/install_command'
require 'rubygems/commands/update_command'
require 'rubygems/commands/uninstall_command'

module Rabbit
  
  module GemManager
    extend self
    
    def installed?(gem_name)
      return Gem::Specification.find_all_by_name(gem_name).size > 0
    end
    
    def install(gem_name)
      return success false if installed? gem_name
      command = Gem::Commands::InstallCommand.new
      command.handle_options [gem_name, '-i', Gem::path.first]
      begin
        command.execute
      rescue Gem::SystemExitException => e
        if e.exit_code == 0
           return success true
        else
          return failure e.exit_code
        end
      end
    end
    
    def update(gem_name)
      #TODO: implement!
    end
    
    def uninstall(gem_name)
      #TODO: implement!      
    end
    
  end
  
end